/*
 * RandomSubstringFactory.cpp
 *
 *  Created on: 27. 3. 2014
 *	  Author: Jan Travnicek
 */

#include "RandomSubstringFactory.h"

#include <algorithm>
#include <random>
#include <exception/AlibException.h>

#include <string/LinearString.h>

namespace string {

namespace generate {

string::LinearString RandomSubstringFactory::generateSubstring ( size_t size, const string::LinearString & string ) {
	if ( size > string.getContent ( ).size ( ) )
		throw exception::AlibException ( "String not long enough" );

	srand ( time ( NULL ) );

	size_t begin = std::random_devices::semirandom ( ) % ( string.getContent ( ).size ( ) - size + 1 );

	std::vector < alphabet::Symbol > data ( string.getContent ( ).begin ( ) + begin, string.getContent ( ).begin ( ) + begin + size );

	return LinearString {
			   string.getAlphabet ( ), data
	};
}

auto RandomSubstringFactoryLinearString = RandomSubstringFactory::RegistratorWrapper < string::LinearString, string::LinearString > ( RandomSubstringFactory::getInstance ( ), RandomSubstringFactory::generateSubstring );

} /* namespace generate */

} /* namespace string */
